<?php

namespace Teknisa\FIN\Modules\ContaReceber\Factory;

use \Teknisa\Model\Financeiro\Entities\GeralRec;
use Teknisa\Libs\Util\DateUtil;
use Doctrine\ORM\EntityManager;

class GeralRecTipoajreceberFactory{
    protected $entityManager;
    protected $connection;

    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
        $this->entityManager = $entityManager;
    }

    public function insereParametroContaReceber ($cdgeralrec, $idbloqincntr, $idtpcntrlib, $idutctrlcanremr,
                                                 $idbloqaltbolrec, $idutlnfdevolrec, $idutbcoprefclie,
                                                 $idextelacalajubx, $nrorg){
        $geralRec = new GeralRec();
        $geralRec->setNrorg($nrorg);
        $geralRec->setCdgeralrec($cdgeralrec);
        $geralRec->setIdbloqincntr($idbloqincntr);
        $geralRec->setIdtpcntrlib($idtpcntrlib);
        $geralRec->setIdutctrlcanremr($idutctrlcanremr);
        $geralRec->setIdbloqaltbolrec($idbloqaltbolrec);
        $geralRec->setIdutlnfdevolrec($idutlnfdevolrec);
        $geralRec->setIdutbcoprefclie($idutbcoprefclie);
        $geralRec->setIdextelacalajubx($idextelacalajubx);
        $geralRec->setDtinclusao(DateUtil::getDataAtual());
        $geralRec->setDtultatu(DateUtil::getDataAtual());
        $geralRec->setNrorginclusao($nrorg);
        $geralRec->setNrorgultatu($nrorg);
        return $geralRec;
    }
    
    public function atualizaTabelaGeralRec($params){

        $sql = "UPDATE GERAL_REC SET IDBLOQINCNTR =:IDBLOQINCNTR,
                                     CDGROPERCNTR =:CDGROPERCNTR,
                                     IDTPCNTRLIB =:IDTPCNTRLIB,
                                     IDUTLPRORVCREC =:IDUTLPRORVCREC,
                                     IDUTCTRLCANREMR =: IDUTCTRLCANREMR
                WHERE CDGERALREC =:CDGERALREC";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        
    }
    
    public function atualizaTabelaParamGeral($params){
        
        $sql = "UPDATE PARAMGERAL SET IDUTLPROCREC =:IDUTLPROCREC,
                                      CDGROPERPROR =:CDGROPERPROR,
                                      CDGROPERRECCONTR =:CDGROPERRECCONTR,
                                      IDCONTROLARECCONTRATO =:IDCONTROLARECCONTRATO
                WHERE CDPARGERAL =:CDPARGERAL";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        
    }
    
    public function verificaOperadoresInseridos($idautgrupop){
        
        $sql = "SELECT A.CDGRUPOPER, A.NRAUTGRUPOP
                  FROM AUTGRUPOP A
                 WHERE  A.IDAUTGRUPOP =  '$idautgrupop'";
        $std = $this->connection->prepare($sql);
        $std->execute();
        return $std->fetchAll();
    }
    
    public function insereAutoGroupPop($dados){
        $sql = "INSERT INTO AUTGRUPOP (CDGRUPOPER, IDAUTGRUPOP, NRAUTGRUPOP)
                            VALUES(:CDGRUPOPER, :IDAUTGRUPOP,:NRAUTGRUPOP)";
        $std = $this->connection->prepare($sql);
        $std->execute($dados);
    }
    
    public function removeGrupoOperadores($param){
        
        $sql = "DELETE FROM AUTGRUPOP
                WHERE  CDGRUPOPER =: CDGRUPOPER";
        $std = $this->connection->prepare($sql);
        $std->execute($param);
    }
}