/* Sistemas Integrados TEKNISA
  Integrao - SAGA

 Nome: Trigger de atualizao da tabela CARACPRODSAGA

Criao:
09/04/2013 - Fabrcio Marcelo

@C:\web_560\sql\end_conv\oracle\01QK_GERTRGS_DTULTATU_CARACPRODSAGA.sql
*/


IF EXISTS(SELECT * 
            FROM sysobjects O, sysusers U
           WHERE o.name = 'DTULTATU_CARACPRODSAGA'
             and type = 'TR'
             and u.uid = o.uid
             and u.name = USER)
   DROP TRIGGER DTULTATU_CARACPRODSAGA
GO

CREATE TRIGGER DTULTATU_CARACPRODSAGA
ON CARACPRODSAGA
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'CARACPRODSAGA', null, 'CDPRODUTO =' + CDPRODUTO + ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE CARACPRODSAGA
         SET DTULTATUCARACP = GETDATE()
        FROM INSERTED
       WHERE (ISNULL(CARACPRODSAGA.CDPRODUTO,0)      = ISNULL(INSERTED.CDPRODUTO,0))
         AND (ISNULL(CARACPRODSAGA.VRPRAZMAXREC,0)   = ISNULL(INSERTED.VRPRAZMAXREC,0))
         AND (ISNULL(CARACPRODSAGA.VRPRAZMAXDEV,0)   = ISNULL(INSERTED.VRPRAZMAXDEV,0))
         AND (ISNULL(CARACPRODSAGA.VRPRAZVALIDADE,0) = ISNULL(INSERTED.VRPRAZVALIDADE,0))
         AND (ISNULL(CARACPRODSAGA.VRPERMARMAZEM,0)  = ISNULL(INSERTED.VRPERMARMAZEM,0))
         AND (ISNULL(CARACPRODSAGA.CDGRUPREGARMAZ,0) = ISNULL(INSERTED.CDGRUPREGARMAZ,0))
         AND (ISNULL(CARACPRODSAGA.VRTEMPMEDESTOQ,0) = ISNULL(INSERTED.VRTEMPMEDESTOQ,0))
         AND (ISNULL(CARACPRODSAGA.VRTEMPMEDEXPED,0) = ISNULL(INSERTED.VRTEMPMEDEXPED,0))
         AND (ISNULL(CARACPRODSAGA.VRTEMPMEDRECEB,0) = ISNULL(INSERTED.VRTEMPMEDRECEB,0))
         AND (ISNULL(CARACPRODSAGA.VRSHELFLIFE   ,0) = ISNULL(INSERTED.VRSHELFLIFE   ,0))
         AND (ISNULL(CARACPRODSAGA.VRJANELAFIFO  ,0) = ISNULL(INSERTED.VRJANELAFIFO  ,0))
         AND (ISNULL(CARACPRODSAGA.VRJANFIFOTRANS,0) = ISNULL(INSERTED.VRJANFIFOTRANS,0))
         AND (ISNULL(CARACPRODSAGA.CDMOTIVOBLOQ  ,0) = ISNULL(INSERTED.CDMOTIVOBLOQ  ,0))
         AND (ISNULL(CARACPRODSAGA.VRLARGURA     ,0) = ISNULL(INSERTED.VRLARGURA     ,0))
         AND (ISNULL(CARACPRODSAGA.VRALTURA      ,0) = ISNULL(INSERTED.VRALTURA      ,0))
         AND (ISNULL(CARACPRODSAGA.VRPROFUNDIDADE,0) = ISNULL(INSERTED.VRPROFUNDIDADE,0))
         AND (ISNULL(CARACPRODSAGA.VRPESO        ,0) = ISNULL(INSERTED.VRPESO        ,0))
         AND (ISNULL(CARACPRODSAGA.VRPESOLIQ     ,0) = ISNULL(INSERTED.VRPESOLIQ     ,0))
         AND (ISNULL(CARACPRODSAGA.VRVOLUME      ,0) = ISNULL(INSERTED.VRVOLUME      ,0))
         AND (ISNULL(CARACPRODSAGA.VRPALPRODALT  ,0) = ISNULL(INSERTED.VRPALPRODALT  ,0))
         AND (ISNULL(CARACPRODSAGA.VRPALPRODCOM  ,0) = ISNULL(INSERTED.VRPALPRODCOM  ,0))
         AND (ISNULL(CARACPRODSAGA.VRFATORSKU    ,0) = ISNULL(INSERTED.VRFATORSKU    ,0))
         AND (ISNULL(CARACPRODSAGA.VRPALPRODLAR  ,0) = ISNULL(INSERTED.VRPALPRODLAR  ,0));
   END;
END;
GO


-- VERSAO --
EXEC TEKNISA.ATUVEROBJ 'DTULTATU_CARACPRODSAGA','5.60.XXX';
GO

