function Pag11001_RelatorioCustomizavelTitulosPagarPagos_Controller(General, ScreenService, templateManager, ZHPromise, ZhFilterPreferences, restEngine) {
    var self = this;
    
    self.setNameLayout = function(args){
        var widget = args.owner;
        if (!widget.hasOwnProperty('labelPrincipal')){
            widget.labelPrincipal = widget.label;
        }
        if (args.e.layout.ID == 'ORIGINAL'){
            widget.container.label = widget.labelPrincipal;
            widget.label = widget.labelPrincipal;
        }else{
            widget.container.label = args.e.layout.LABEL_TO_PREFERENCE;
            widget.label = args.e.layout.LABEL_TO_PREFERENCE;
        }
    };
     
    self.openFilterTitulosAPagar = function(widgetTitulosAPagar){
        self.buscaDadosIniciaisFiltro(widgetTitulosAPagar).then(function(){
            var rowSetFilter = {
                'DTVENBOLPAG' : widgetTitulosAPagar.DTVENBOLPAG,
                'CDEMPRESA'   : [widgetTitulosAPagar.empresa.CDEMPRESA]
            };
            ZhFilterPreferences.setOriginalFilter(widgetTitulosAPagar.id, rowSetFilter);
            ZhFilterPreferences.openFilterWidget(widgetTitulosAPagar, rowSetFilter);
        });

    };
    
    self.buscaDadosIniciaisFiltro = function(widgetTitulosAPagar) {
        var deferred = ZHPromise.defer();
        self.buscaPadraoEmpresa(widgetTitulosAPagar).then(function(){
            self.buscaPadraoIntervaloVencimento(widgetTitulosAPagar).then(function(){
                deferred.resolve();        
            });    
        });
        
        return deferred.promise;
    };
    
    self.buscaPadraoEmpresa = function(widget) {
        var deferred = ZHPromise.defer();
        var filterFilial = [{"name": "CDFILIAL", "operator": "=", "value": "FILIAL_LOGADA"}];
        var routeFilial = 'fin#/crud/filial';
        General.callRestEngine(routeFilial, 'FilterData', filterFilial).then(function(response_filial){
            var filial   = response_filial.dataset.filial[0];
            var routeEmpresa = 'fin#/crud/empresa';
            var filterEmpresa = [{"name": "CDEMPRESA", "operator": "=", "value": filial.CDEMPRESA}];
            General.callRestEngine(routeEmpresa, 'FilterData', filterEmpresa).then(function(response_empresa){
                var empresa = response_empresa.dataset.empresa[0];
                widget.empresa = empresa;
                deferred.resolve();
            });
        });
        
        return deferred.promise;
    };
    
    self.buscaGeralPag = function(){
        return General.callRestEngine(
            'fin#/crud/geral_pag',
            'FilterData',
            []
        );
    };
    
    self.buscaParamEstoque = function(cdFilialOpcional) {
        var filter = [{"name": "CDFILIAL", "operator": "=", "value": 'FILIAL_LOGADA'}];
        return General.callRestEngine(
            'fin#/crud/paramestoque_processamento',
            'FilterData',
            filter
        ); 
    };
    
    self.buscaPadraoIntervaloVencimento = function (widget){
        var deferred = ZHPromise.defer();
        var geralpag     = self.buscaGeralPag();
        var paramestoque = self.buscaParamEstoque();

        ZHPromise.all([geralpag, paramestoque]).then(function(response){
            geralpag     = response[0].dataset.geral_pag[0];
            paramestoque = response[1].dataset.paramestoque_processamento[0];

            var qtdiaantlanr = geralpag?geralpag.QTDIAANTBOLP?geralpag.QTDIAANTBOLP:0:0;
            var qtdiaapolanr = geralpag?geralpag.QTDIAAPOBOLP?geralpag.QTDIAAPOBOLP:0:0;
            var dtprocessa   = paramestoque?paramestoque.DTPROCESSA?paramestoque.DTPROCESSA:moment():moment();

            var start = moment(dtprocessa, 'DD/MM/YYYY').subtract(qtdiaantlanr, 'days').format('DD/MM/YYYY');
            var end   = moment(dtprocessa, 'DD/MM/YYYY').add(qtdiaapolanr, 'days').format('DD/MM/YYYY');

            widget.DTVENBOLPAG = {start : start, end : end};
            deferred.resolve();
        });
        return deferred.promise;
    };
    
    
    self.buildFilter = function (widget, preference) {
        var filtro = widget.dataSourceFilter;
        var filterRow = preference.FILTER_ROW;
        
        validateStartEndValues(filterRow);
        
        filtro.forEach(function(fil, index) {
            switch (fil.name) {
                case 'CDEMPRESA':
                    fil.value = filterRow.CDEMPRESA ? filterRow.CDEMPRESA.join("_") : null;
                    break;
                case 'DTVENBOLPAGINI':
                    fil.value = filterRow.DTVENBOLPAG ? filterRow.DTVENBOLPAG.start : null;
                    break;
                case 'DTVENBOLPAGFIN':
                    fil.value = filterRow.DTVENBOLPAG ? filterRow.DTVENBOLPAG.end : null;
                    break;
                case 'DTEMISSAOINI':
                    fil.value = filterRow.DTEMISSAO ? filterRow.DTEMISSAO.start : null;
                    break;
                case 'DTEMISSAOFIN':
                    fil.value = filterRow.DTEMISSAO ? filterRow.DTEMISSAO.end : null;
                    break;
                case 'DTENTRSAIDINI':
                    fil.value = filterRow.DTENTRSAID ? filterRow.DTENTRSAID.start : null;
                    break;
                case 'DTENTRSAIDFIN':
                    fil.value = filterRow.DTENTRSAID ? filterRow.DTENTRSAID.end : null;
                    break;
                case 'DTCNABPAGINI':
                    fil.value = filterRow.DTCNABPAG ? filterRow.DTCNABPAG.start : null;
                    break;
                case 'DTCNABPAGFIN':
                    fil.value = filterRow.DTCNABPAG ? filterRow.DTCNABPAG.end : null;
                    break;
                case 'DTBAXINICIAL':
                    fil.value = filterRow.DTBAIXAPAG ? filterRow.DTBAIXAPAG.start : null;
                    break;
                case 'DTBAXFINAL':
                    fil.value = filterRow.DTBAIXAPAG ? filterRow.DTBAIXAPAG.end : null;
                    break;
                case 'TDTBAIXA':
                    fil.value = filterRow.DTBAIXAPAG ? filterRow.DTBAIXAPAG.start ? null : 'T' : 'T';
                    break;
                case 'DTLBAINICIAL':
                    fil.value = filterRow.DTLANCBAIXAP ? filterRow.DTLANCBAIXAP.start : null;
                    break;
                case 'DTLBAFINAL':
                    fil.value = filterRow.DTLANCBAIXAP ? filterRow.DTLANCBAIXAP.end : null;
                    break;
                case 'TDTLBAIXA':
                    fil.value = filterRow.DTLANCBAIXAP ? filterRow.DTLANCBAIXAP.start ? null : 'T' : 'T';
                    break;
                case 'VRBAIXAPAGINI':
                    fil.value = filterRow.VRBAIXAPAGINI && filterRow.VRBAIXAPAGFIN ? filterRow.VRBAIXAPAGINI : null;
                    break;
                case 'VRBAIXAPAGFIN':
                    fil.value = filterRow.VRBAIXAPAGINI && filterRow.VRBAIXAPAGFIN ? filterRow.VRBAIXAPAGFIN : null;
                    break;
                case 'TVRBAIXA':
                    fil.value = filterRow.VRBAIXAPAGINI && filterRow.VRBAIXAPAGFIN ? null : 'T';
                    break;
            }
        });
        filtro = getDataSourceWithoutIntervalFieldNames(filtro);
        
        preference.CUSTOM_FILTER_ROW = {
            'CDFORNECED'   : preference.FILTER_ROW.CDFORNECED,
            'IDSTATBPAG'   : preference.FILTER_ROW.IDSTATBPAG,
            'IDHABIBPAG'   : preference.FILTER_ROW.IDHABIBPAG,
            'CDFILIRECE'   : preference.FILTER_ROW.CDFILIRECE,
            'CDFILIALNF'   : preference.FILTER_ROW.CDFILIALNF,
            'CDTPCTPAGAR'  : preference.FILTER_ROW.CDTPCTPAGAR,
            'CDCLASSFINA'  : preference.FILTER_ROW.CDCLASSFINA,
            'CDTIPOOPER'   : preference.FILTER_ROW.CDTIPOOPER,
            'IDSTATUS'     : preference.FILTER_ROW.IDSTATUS,
            'IDSITUCNABP'  : preference.FILTER_ROW.IDSITUCNABP,
            'CDTPBAIXAPAG' : preference.FILTER_ROW.CDTPBAIXAPAG
        };
    };
    
    self.changeInputValues = function(widget, preference) {
        var filterRow = preference.FILTER_ROW;
        validateStartEndValues(filterRow);
    };
    
    //Limpa os nomes dos campos invterval do dataSource
    var getDataSourceWithoutIntervalFieldNames = function(filtro){
        for(var i = 0; i < filtro.length; i++) {
            if(filtro[i].name === 'DTEMISSAO' ||
               filtro[i].name === 'DTENTRSAID' ||
               filtro[i].name === 'DTVENBOLPAG' ||
               filtro[i].name === 'DTCNABPAG' ||
               filtro[i].name === 'DTBAIXAPAG' ||
               filtro[i].name === 'DTLANCBAIXAR' ) {
                filtro.splice(i, 1);
                i--;
            }
        }
        return filtro;
    };
    
    /*
     * Verificação para igualar valores iniciais e finais do filtro, no caso
     * do usuário preencher um e deixar o outro em branco. Isso irá fazer
     * com que a query retorne somente resultados que sejam exatamente os  
     * mesmos valores inseridos em um dos campos.
     */
    var validateStartEndValues = function(filterRow) {
        // Verifica valor do boleto inicial e final.
        filterRow.VRBOLPAGINI = filterRow.VRBOLPAGINI || filterRow.VRBOLPAGFIN || null;
        filterRow.VRBOLPAGFIN = filterRow.VRBOLPAGFIN || filterRow.VRBOLPAGINI;
        
        // Verifica valor líquido inicial e final.
        filterRow.VRFINALBPAGINI = filterRow.VRFINALBPAGINI || filterRow.VRFINALBPAGFIN || null;
        filterRow.VRFINALBPAGFIN = filterRow.VRFINALBPAGFIN || filterRow.VRFINALBPAGINI;
        
        // Verifica nota fiscal inicial e final.
        filterRow.NRNOTAFISCINI = filterRow.NRNOTAFISCINI || filterRow.NRNOTAFISCFIN || null;
        filterRow.NRNOTAFISCFIN = filterRow.NRNOTAFISCFIN || filterRow.NRNOTAFISCINI;
        
        // Verifica valor da baixa inicial e final.
        filterRow.VRBAIXAPAGINI = filterRow.VRBAIXAPAGINI || filterRow.VRBAIXAPAGFIN || null;
        filterRow.VRBAIXAPAGFIN = filterRow.VRBAIXAPAGFIN || filterRow.VRBAIXAPAGINI;
        
        // Verifica número remessa inicial e final.
        filterRow.NRCNABPAGREMINI = filterRow.NRCNABPAGREMINI || filterRow.NRCNABPAGREMFIN || null;
        filterRow.NRCNABPAGREMFIN = filterRow.NRCNABPAGREMFIN || filterRow.NRCNABPAGREMINI;
        
        // Verifica número retorno inicial e final.
        filterRow.NRCNABPAGRETINI = filterRow.NRCNABPAGRETINI || filterRow.NRCNABPAGRETFIN || null;
        filterRow.NRCNABPAGRETFIN = filterRow.NRCNABPAGRETFIN || filterRow.NRCNABPAGRETINI;
        
        // Verifica valor remessa inicial e final.
        filterRow.VRTOTBOLCNABPAGINI = filterRow.VRTOTBOLCNABPAGINI || filterRow.VRTOTBOLCNABPAGFIN || null;
        filterRow.VRTOTBOLCNABPAGFIN = filterRow.VRTOTBOLCNABPAGFIN || filterRow.VRTOTBOLCNABPAGINI;
    };
    
    this.changeHeaderValues = function(widget){
        /*var codigo; 
        var nmempresa = widget.owner.dataSource.data[0].NMEMPRESA;
        widget.owner.dataSourceFilter.forEach(function(empresa){
           if(empresa.name == 'CDEMPRESA'){
               codigo = empresa.value;
           } 
        });
        
        var cdempresa = {
            'label' : "Empresa",
            'value' : "is equal to".concat(codigo).concat(' - ').concat(nmempresa)
        };*/
        
        var filter = widget.e.metadata.filter;
        var newFilter = [];
        //newFilter.push(cdempresa);
        filter.forEach(function(x){
            if(x.value != "é igual a."){
                newFilter.push(x);
            }
        });
        
        var correctFilter = [];
        var value;
        newFilter.forEach(function(aux){
            if(aux.value.match(/é igual a/)){
                value = aux.value.substr(11);
                aux.value = value;
                correctFilter.push(aux);
            }else if(aux.value.match(/está entre/)){
                value = aux.value.substr(11);
                aux.value = value;
                correctFilter.push(aux);
            }
        });
        
        widget.e.metadata.filter = correctFilter;    
        
        
    };
    
    
    self.onChangeEmpresaFilter = function(widget){
        var cdempresa = widget.currentRow.CDEMPRESA;
        var cdtpctpagar = widget.getField('CDTPCTPAGAR');
        
        cdtpctpagar.setValue("");
        if(Array.isArray(cdempresa)){
            cdtpctpagar.dataSourceFilter[0].value = "";
            cdempresa.forEach(function(empresa){
                cdtpctpagar.dataSourceFilter[0].value = cdtpctpagar.dataSourceFilter[0].value+empresa+'_';
            });
            cdtpctpagar.dataSourceFilter[0].value = '_'+cdtpctpagar.dataSourceFilter[0].value;
        } else {
            cdtpctpagar.dataSourceFilter[0].value = cdempresa;
        }
        cdtpctpagar.reload();
    };
}

Configuration(function (ContextRegister) {
	ContextRegister.register('Pag11001_RelatorioCustomizavelTitulosPagarPagos_Controller', Pag11001_RelatorioCustomizavelTitulosPagarPagos_Controller);
});