function Rec11002_RelatorioCustomizavelTitulosReceberRecebidos_Controller (General, ScreenService, templateManager, ZHPromise, ZhFilterPreferences, restEngine) {
    var self = this; 
    
    self.setNameLayout = function(args){
        var widget = args.owner;
        if (!widget.hasOwnProperty('labelPrincipal')){
            widget.labelPrincipal = widget.label;
        }
        if (args.e.layout.ID == 'ORIGINAL'){
            widget.container.label = widget.labelPrincipal;
            widget.label = widget.labelPrincipal;
        }else{
            widget.container.label = args.e.layout.LABEL_TO_PREFERENCE;
            widget.label = args.e.layout.LABEL_TO_PREFERENCE;
        }
    };
     
    self.openFilterTitulosAReceber = function(widgetTitulosAReceber){
        self.buscaDadosIniciaisFiltro(widgetTitulosAReceber).then(function(){
            var rowSetFilter = {
                //'DTVENBOLREC' : widgetTitulosAReceber.DTVENBOLREC,
                'CDEMPRESA'   : widgetTitulosAReceber.empresa.CDEMPRESA,
                'NMEMPRESA'   : widgetTitulosAReceber.empresa.NMEMPRESA
            };
            ZhFilterPreferences.setOriginalFilter(widgetTitulosAReceber.id, rowSetFilter);
            ZhFilterPreferences.openFilterWidget(widgetTitulosAReceber, rowSetFilter);
        });

    };
    
    self.buscaDadosIniciaisFiltro = function(widgetTitulosAReceber) {
        var deferred = ZHPromise.defer();
        self.buscaPadraoEmpresa(widgetTitulosAReceber).then(function(){
            self.buscaPadraoIntervaloVencimento(widgetTitulosAReceber).then(function(){
                deferred.resolve();        
            });    
        });
        
        return deferred.promise;
    };
    
    self.buscaPadraoEmpresa = function(widget) {
        var deferred = ZHPromise.defer();
        var filterFilial = [{"name": "CDFILIAL", "operator": "=", "value": "FILIAL_LOGADA"}];
        var routeFilial = 'fin#/crud/filial';
        General.callRestEngine(routeFilial, 'FilterData', filterFilial).then(function(response_filial){
            var filial   = response_filial.dataset.filial[0];
            var routeEmpresa = 'fin#/crud/empresa';
            var filterEmpresa = [{"name": "CDEMPRESA", "operator": "=", "value": filial.CDEMPRESA}];
            General.callRestEngine(routeEmpresa, 'FilterData', filterEmpresa).then(function(response_empresa){
                var empresa = response_empresa.dataset.empresa[0];
                widget.empresa = empresa;
                deferred.resolve();
            });
        });
        
        return deferred.promise;
    };
    
    self.buscaGeralRec = function(){
        return General.callRestEngine(
            'fin#/crud/geral_rec',
            'FilterData',
            []
        );
    };
    
    self.buscaParamEstoque = function(cdFilialOpcional) {
        var filter = [{"name": "CDFILIAL", "operator": "=", "value": 'FILIAL_LOGADA'}];
        return General.callRestEngine(
            'fin#/crud/paramestoque_processamento',
            'FilterData',
            filter
        );
    };
    
    self.buscaPadraoIntervaloVencimento = function (widget){
        var deferred = ZHPromise.defer();
        var geralrec     = self.buscaGeralRec();
        var paramestoque = self.buscaParamEstoque();

        ZHPromise.all([geralrec, paramestoque]).then(function(response){
            geralrec     = response[0].dataset.geral_rec[0];
            paramestoque = response[1].dataset.paramestoque_processamento[0];

            var qtdiaantlanr = geralrec?geralrec.QTDIAANTBOLR?geralrec.QTDIAANTBOLR:0:0;
            var qtdiaapolanr = geralrec?geralrec.QTDIAAPOBOLR?geralrec.QTDIAAPOBOLR:0:0;
            var dtprocessa   = paramestoque?paramestoque.DTPROCESSA?paramestoque.DTPROCESSA:moment():moment();

            var start = moment(dtprocessa, 'DD/MM/YYYY').subtract(qtdiaantlanr, 'days').format('DD/MM/YYYY');
            var end   = moment(dtprocessa, 'DD/MM/YYYY').add(qtdiaapolanr, 'days').format('DD/MM/YYYY');

            //widget.DTVENBOLREC = {start : start, end : end};
            deferred.resolve();
        });
        return deferred.promise;
    };
    
    
    self.buildFilter = function (widget, preference) {
        var filtro = widget.dataSourceFilter;
        var filterRow = preference.FILTER_ROW;
        filtro.forEach(function(fil) {
            if (Array.isArray(fil.value)) {
                fil.value = fil.value.join("_");
            }
            switch (fil.name) {
                
                case 'VALORINI':
                    fil.value = filterRow.VALORINI ? filterRow.VALORINI : null;
                    break;
                
                case 'VALORFIN':
                    fil.value = filterRow.VALORFIN ? filterRow.VALORFIN : null;
                    break;
                
                case 'DATENTR':
                    fil.value = filterRow.ENTRADA ? filterRow.ENTRADA.start : null;
                    break;
                
                case 'DATSAID':
                    fil.value = filterRow.ENTRADA ? filterRow.ENTRADA.end : null;
                    break;
                
                case 'DATEMISINI':
                    fil.value = filterRow.EMISSAO ? filterRow.EMISSAO.start : null;
                    break;
                
                case 'DATEMIFIN':
                    fil.value = filterRow.EMISSAO ? filterRow.EMISSAO.end : null;
                    break;
                
                case 'DTATUAVENRECINI':
                    fil.value = filterRow.VENCIMENTO ? filterRow.VENCIMENTO.start : null;
                    break;
                
                case 'DTATUAVENRECFIN':
                    fil.value = filterRow.VENCIMENTO ? filterRow.VENCIMENTO.end : null;
                    break;
                
                case 'IDTPCTRECEBER':
                    fil.value = filterRow.IDTPCTRECEBER ? filterRow.IDTPCTRECEBER : null;
                    break;
                
                case 'CODFILILANC':
                    fil.value = filterRow.CDFILIAL ? filterRow.CDFILIAL : 'T';
                    break;
                
                case 'STATUS':
                    fil.value = filterRow.STATUS ? filterRow.STATUS : 'T';
                    break;
                
                case 'TIPO':
                    fil.value = filterRow.IDSTATUS ? filterRow.IDSTATUS : 'A_E'; 
                    break;
                
                case 'TIPOCONTA':
                    fil.value = filterRow.CDTPCTRECEB ? filterRow.CDTPCTRECEB : 'T';
                    break;
                
                case 'P_CLASSFINA':
                    fil.value = filterRow.CDCLASSFINA ? filterRow.CDCLASSFINA: 'T';
                    break;
                
                case 'IDBLOQNFFIN':
                    if(filterRow.IDBLOQNFFIN == null){
                        filterRow.IDBLOQNFFIN = 'L';
                    }
                    fil.value = filterRow.IDBLOQNFFIN ? filterRow.IDBLOQNFFIN : 'L';
                    break;
                
                case 'P_FORMA':
                    fil.value = filterRow.CDTPBAIXAREC ? filterRow.CDTPBAIXAREC : 'T';
                    break;
                
                case 'P_CCORR':
                    fil.value = filterRow.CDREDUCONT ? filterRow.CDREDUCONT : 'T';
                    break;
                                
                case 'P_TOPERLANC':
                    fil.value = filterRow.CDOPERACTPG ? null : 'T';
                    break;
                
                case 'P_OPERLANC':
                    fil.value = filterRow.CDOPERACTPG ? filterRow.CDOPERACTPG : null;
                    break;
                
                 case 'P_TCDTIPOOPER':
                    fil.value = filterRow.CDTIPOOPER ? null : 'T';
                    break;
                
                case 'P_CDTIPOOPER':
                    fil.value = filterRow.CDTIPOOPER ? filterRow.CDTIPOOPER : null;
                    break;
                    
                case 'IDSISTEMA':
                    fil.value = filterRow.IDSISTEMA ? filterRow.IDSISTEMA : 'T';
                    break;
                    
                case 'P_EMPRESA':
                    fil.value = filterRow.CDEMPRESA ? filterRow.CDEMPRESA.join("_"): null;
                    break;
            }
            
        });
        delete filterRow.CDEMPRESA;
        delete filterRow.NMEMPRESA;
        filtro = getDataSourceWithoutIntervalFieldNames(filtro);
    };
    
    self.changeInputValues = function(widget, preference) {
        var filterRow = preference.FILTER_ROW;
        validateStartEndValues(filterRow);
    };
    
    //Limpa os nomes dos campos invterval do dataSource
    var getDataSourceWithoutIntervalFieldNames = function(filtro){
        for(var i = 0; i < filtro.length; i++) {
            if(filtro[i].name === 'DTEMISSAO' ||
               filtro[i].name === 'DTENTRSAID' ||
               filtro[i].name === 'DTVENBOLREC' ||
               filtro[i].name === 'DTBAIXAREC' ) {
                filtro.splice(i, 1);
                i--;
            }
        } 
        return filtro;
    };
    
    /*
     * Verificação para igualar valores iniciais e finais do filtro, no caso
     * do usuário preencher um e deixar o outro em branco. Isso irá fazer
     * com que a query retorne somente resultados que sejam exatamente os  
     * mesmos valores inseridos em um dos campos.
     */
    var validateStartEndValues = function(filterRow) {
        // Verifica valor líquido inicial e final.
        filterRow.VRFINALBRECINI = filterRow.VRFINALBRECINI || filterRow.VRFINALBRECFIN || null;
        filterRow.VRFINALBRECFIN = filterRow.VRFINALBRECFIN || filterRow.VRFINALBRECINI;
        
        // Verifica nota fiscal inicial e final.
        filterRow.NRNOTAFISCINI = filterRow.NRNOTAFISCINI || filterRow.NRNOTAFISCFIN || null;
        filterRow.NRNOTAFISCFIN = filterRow.NRNOTAFISCFIN || filterRow.NRNOTAFISCINI;
        
        // Verifica valor da baixa inicial e final.
        filterRow.VRBAIXARECINI = filterRow.VRBAIXARECINI || filterRow.VRBAIXARECFIN || null;
        filterRow.VRBAIXARECFIN = filterRow.VRBAIXARECFIN || filterRow.VRBAIXARECINI;
        
        // Verifica número remessa inicial e final.
        // Verifica valor remessa inicial e final.
        filterRow.VRTOTBOLCNABRECINI = filterRow.VRTOTBOLCNABRECINI || filterRow.VRTOTBOLCNABRECFIN || null;
        filterRow.VRTOTBOLCNABRECFIN = filterRow.VRTOTBOLCNABRECFIN || filterRow.VRTOTBOLCNABRECINI;
    };
    
    
    
    this.changeHeaderValues = function(widget){
        /*var codigo; 
        var nmempresa = widget.owner.dataSource.data[0].NMEMPRESA;
        widget.owner.dataSourceFilter.forEach(function(empresa){
           if(empresa.name == 'CDEMPRESA'){
               codigo = empresa.value;
           } 
        });
        
        var cdempresa = {
            'label' : "Empresa",
            'value' : "is equal to".concat(codigo).concat(' - ').concat(nmempresa)
        };*/
        
        var filter = widget.e.metadata.filter;
        var newFilter = [];
        //newFilter.push(cdempresa);
        filter.forEach(function(x){
            if(x.value != "é igual a."){
                newFilter.push(x);
            }
        });
        
        var correctFilter = [];
        var value;
        newFilter.forEach(function(aux){
            if(aux.value.match(/é igual a/)){
                value = aux.value.substr(11);
                aux.value = value;
                correctFilter.push(aux);
            }else if(aux.value.match(/está entre/)){
                value = aux.value.substr(11);
                aux.value = value;
                correctFilter.push(aux);
            }
        });
        
        widget.e.metadata.filter = correctFilter;    
        
        
    };
}

Configuration(function (ContextRegister) {
	ContextRegister.register('Rec11002_RelatorioCustomizavelTitulosReceberRecebidos_Controller', Rec11002_RelatorioCustomizavelTitulosReceberRecebidos_Controller);
});